#!bash


# Colores
AMARILLO="\033[1;33m"
AZUL="\033[0;34m"
BLANCO="\033[1;37m"
CYAN="\033[0;36m "
GRIS="\033[1;30m"
MARRON="\033[0;33m"
MORADO="\033[0;35m"
ROJO="\033[0;31m"
VERDE="\033[0;32m"
SIN_COLOR="\033[0m"
LIGHT_AZUL="\033[1;34m"
LIGHT_CYAN="\033[1;36m"
LIGHT_GRIS="\033[0;37m"
LIGHT_MORADO="\033[1;35m"
LIGHT_ROJO="\033[1; 31m"
LIGHT_VERDE="\033[1;32m"

# Variables globales
DEBUG=1  					# 1 o 0 dependiendo si está o no activo el debug
 

export LS_OPTIONS='--color=auto'
eval `dircolors`
alias ls='ls $LS_OPTIONS'



#
# Presenta el programa
# 
function presentarPrograma(){
	echo -e "\n\n${AZUL}Parseador de Excels ${SIN_COLOR}\n\n"
	if [ $DEBUG -eq 1 ]; then 	
		read
	fi
}





#
# Dado un fichero de Excel lo transforma a CSV
#
function transformaEXCEL2CSV (){
# $1 Es el fichero a tratar

	if [ $DEBUG -eq 1 ]; then 	
		echo -e "${MORADO}\t\tConvirtiendo a CSV el fichero de Excel $1 ${SIN_COLOR}\n"
		read
	fi

	NUMEROHOJAS=`bash ./getNumeroHojas.sh "$1"`

	if [ $DEBUG -eq 1 ]; then 	
		echo -e "${MORADO}\t\t El fichero de Excel $1 tiene $NUMEROHOJAS hojas ${SIN_COLOR}\n"
		read
	fi

	CONTADOR=0
	while [  $CONTADOR -lt $NUMEROHOJAS ]; do  # Para cada una de las hojas
             echo -e "${MORADO}\t\tConvertida la hoja $CONTADOR${SIN_COLOR}\n"  # Convertimos las hojas a un único csv
	     xlhtml -fw -asc -xp:$CONTADOR  "$1" >> "${1}"."temp" # La libreria no permite mezclar los 2 canales 
             let CONTADOR=CONTADOR+1 
         done
	mv "${1}.temp" "${1}"				    # por eso renombro la salida
}




#
# Transforma cualquier tipo de fichero a CSV
#
function transforma2CSV(){
# $1 es el fichero que tenemos que transformar


	if [ $DEBUG -eq 1 ]; then 	
		echo -e "${MORADO}\t\tTransformando el fichero $1 a CSV ${SIN_COLOR}\n"
		read
	fi


	TIPO_FICHERO=`file -b "$1"`
	if [ "$TIPO_FICHERO" == "Microsoft Office Document" ]; then	# Si es un Excel
		if [ $DEBUG -eq 1 ]; then 	
			echo -e "${MORADO}\t\tEl fichero $1 es EXCEL  ${SIN_COLOR}\n"
			read
		fi
		transformaEXCEL2CSV "$1"	     	           	# Transformamos el fichero a CSV
	else	
		#Puede ser un txt, un IdeTrans.. ya se irá viendo....
		echo "El fichero  $1 no es un Excel"
	fi
}





#
# Borra la pantalla de la consola
#
function borrarPantalla(){
	if [ $DEBUG -eq 1 ]; then 	
		echo -e "\n\n${MORADO}Limpiando la pantalla ${SIN_COLOR}\n\n"
		read
	else
		clear;
	fi
}



 
 




 





#programa principal
presentarPrograma;
transforma2CSV	"$1"










